namespace GraphProgrammatically
{
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using Telerik.Reporting;
    using Telerik.Reporting.Drawing;

    /// <summary>
    /// Summary description for Report1.
    /// </summary>
    public partial class Report1 : Telerik.Reporting.Report
    {
        public Report1()
        {
            //
            // Required for telerik Reporting designer support
            //
            InitializeComponent();
            CreateGraph();
            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        void CreateGraph()
        {
            var myGraphStructure = new MySampleGraphStructure();

            //Instantiate a new Graph
            var graph1 = new Telerik.Reporting.Graph();

            //The name property should be set for all report objects!
            graph1.Name = myGraphStructure.Name;

            //Set the desired graph size
            graph1.Size = new Telerik.Reporting.Drawing.SizeU(Telerik.Reporting.Drawing.Unit.Cm(13), Telerik.Reporting.Drawing.Unit.Cm(7));

            //Set the desired graph location.
            //We place the graph item in the parent container's top left corner.
            graph1.Location = new Telerik.Reporting.Drawing.PointU(Telerik.Reporting.Drawing.Unit.Cm(0), Telerik.Reporting.Drawing.Unit.Cm(0));

            //Set the DataSource property to the list of data points in your custom object.
            graph1.DataSource = myGraphStructure.DataPoints;

            //Create the category group.
            //The CategoryGroups hierarchy defines the data points in the Graph series. 
            var xCategoryGroup = new Telerik.Reporting.GraphGroup();
            xCategoryGroup.Name = "XCategoryGroup";
            xCategoryGroup.Groupings.Add(new Telerik.Reporting.Grouping("=Fields.X"));
            xCategoryGroup.Sortings.Add(new Telerik.Reporting.Sorting("=Fields.X", Telerik.Reporting.SortDirection.Asc));
            graph1.CategoryGroups.Add(xCategoryGroup);

            //The SeriesGroups hierarchy defines the series at runtime. - there is no series grouping in the example
            var seriesGroup1 = new Telerik.Reporting.GraphGroup();
            seriesGroup1.Name = "seriesGroup1";
            graph1.SeriesGroups.Add(seriesGroup1);

            //Configure the X axis category scale
            var graphAxisNumericalScaleX = new Telerik.Reporting.GraphAxis();
            graphAxisNumericalScaleX.Name = "GraphAxis1";
            graphAxisNumericalScaleX.Scale = new Telerik.Reporting.CategoryScale();

            //Configure the Y axis numerical scale
            var graphAxisNumericScaleY = new Telerik.Reporting.GraphAxis();
            graphAxisNumericScaleY.Name = "GraphAxis2";
            graphAxisNumericScaleY.Scale = new Telerik.Reporting.NumericalScale();
            (graphAxisNumericScaleY.Scale as NumericalScale).Minimum = myGraphStructure.YAxisMinimum;

            //The Graph item uses a two-dimensional coordinate system that uniquely identifies the position of each data point. 
            //Each coordinate system consists of two axes(reference lines) and an origin. 
            var cartesianCoordinateSystem1 = new Telerik.Reporting.CartesianCoordinateSystem();
            cartesianCoordinateSystem1.Name = "cartesianCoordinateSystem1";
            cartesianCoordinateSystem1.XAxis = graphAxisNumericalScaleX;
            cartesianCoordinateSystem1.YAxis = graphAxisNumericScaleY;
            graph1.CoordinateSystems.Add(cartesianCoordinateSystem1);

            //create bar series
            var barSeries1 = new Telerik.Reporting.BarSeries();
            barSeries1.CategoryGroup = xCategoryGroup;
            barSeries1.SeriesGroup = seriesGroup1;
            barSeries1.CoordinateSystem = cartesianCoordinateSystem1;
            barSeries1.Legend = "= Fields.MyPointLabel";

            barSeries1.Y = "=Fields.Y";
            graph1.Series.Add(barSeries1);

            graph1.Titles.Add(new GraphTitle() { Text = myGraphStructure.Title });
            //Add the graph item in parent container.
            //We add the graph item in the report's detail section.
            this.detail.Items.Add(graph1);

        }
    }
}